---
title: >-
  SyntaxError: applying the 'delete' operator to an unqualified name is
  deprecated
slug: Web/JavaScript/Reference/Errors/Delete_in_strict_mode
tags:
  - Error
  - Errors
  - JavaScript
  - SyntaxError
---
<div>{{jsSidebar("Errors")}}</div>

<p>The JavaScript <a href="/en-US/docs/Web/JavaScript/Reference/Strict_mode">strict mode</a>-only exception "applying the 'delete' operator to an unqualified name is deprecated" occurs when variables are attempted to be deleted using the <code><a href="/en-US/docs/Web/JavaScript/Reference/Operators/delete">delete</a></code> operator.</p>

<h2 id="Message">Message</h2>

<pre class="syntaxbox">SyntaxError: Calling delete on expression not allowed in strict mode (Edge)
SyntaxError: applying the 'delete' operator to an unqualified name is deprecated (Firefox)
SyntaxError: Delete of an unqualified identifier in strict mode. (Chrome)
</pre>

<h2 id="Error_type">Error type</h2>

<p>{{jsxref("SyntaxError")}} in <a href="/en-US/docs/Web/JavaScript/Reference/Strict_mode">strict mode</a> only.</p>

<h2 id="What_went_wrong">What went wrong?</h2>

<p>Normal variables in JavaScript can't be deleted using the <code><a href="/en-US/docs/Web/JavaScript/Reference/Operators/delete">delete</a></code> operator. In strict mode, an attempt to delete a variable will throw an error and is not allowed.</p>

<p>The <code>delete</code> operator can only delete properties on an object. Object properties are "qualified" if they are configurable.</p>

<p>Unlike what common belief suggests, the <code>delete</code> operator has <strong>nothing</strong> to do with directly freeing memory. Memory management is done indirectly via breaking references, see the <a href="/en-US/docs/Web/JavaScript/Memory_Management">memory management</a> page and the <code><a href="/en-US/docs/Web/JavaScript/Reference/Operators/delete">delete</a></code> operator page for more details.</p>

<p>This error only happens in <a href="/en-US/docs/Web/JavaScript/Reference/Strict_mode">strict mode code</a>. In non-strict code, the operation just returns <code>false</code>.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Freeing_the_contents_of_a_variable">Freeing the contents of a variable</h3>

<p>Attempting to delete a plain variable, doesn't work in JavaScript and it throws an error in strict mode:</p>

<pre class="brush: js example-bad">'use strict';

var x;

// ...

delete x;

// SyntaxError: applying the 'delete' operator to an unqualified name
// is deprecated
</pre>

<p>To free the contents of a variable, you can set it to {{jsxref("null")}}:</p>

<pre class="brush: js example-good">'use strict';

var x;

// ...

x = null;

// x can be garbage collected
</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li><code><a href="/en-US/docs/Web/JavaScript/Reference/Operators/delete">delete</a></code></li>
 <li><a href="/en-US/docs/Web/JavaScript/Memory_Management">Memory management</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Errors/Cant_delete">TypeError: property "x" is non-configurable and can't be deleted</a></li>
</ul>
